//
// dictionary.cpp
//

#include <string>
#include <iostream>
using namespace std;

#include "dictionary.h"

Dictionary::Dictionary (  )
{
	//
	// establish a connection to the database
	//
	if ( db.init (  ) != DB_COMMAND_OK )
	{
		cerr << "Unable to initialize database: " << db.
			error_message (  ) << endl;
		exit ( 1 );
	}

	// Connect to database on localhost
	if ( db.connect ( "localhost", "NICOLE" ) != DB_CONNECTION_OK )
	{
		cerr << "Unable connect to database 'NICOLE': "
			<< db.error_message (  ) << endl;
		exit ( 1 );
	}

}

bool Dictionary::add ( string s )
{

	if ( !exists ( s ) )
	{
		// DEBUG: cout << "Adding word ->" << s.c_str() << "<-" << endl;
		// Insert a single row into the dictionary table
		db.exec ( &dbres, "INSERT INTO dictionary VALUES ('%s', 1)",
							s.c_str (  ) );
		if ( dbres.status (  ) != DB_COMMAND_OK )
		{
			//
			// We shouldn't get this far, as we have already checked if the record existed.
			//
			cerr << "Can't insert into table 'dictionary' : " << db.
				error_message (  ) << endl;
			exit ( 1 );
		}
	}
	else
	{
		update ( s );
	}

	return 1;
}

bool Dictionary::exists ( string s )
{
	char **field;

	db.exec ( &dbres, "SELECT word FROM dictionary WHERE word LIKE '%s'",
						s.c_str (  ) );
	field = dbres.getTuple (  );
	if ( field == NULL )
	{
		return false;
	}
	else
	{
		return true;
	}
}

// update the word entry in the databse

bool Dictionary::update ( string s )
{

	db.exec ( &dbres, "UPDATE dictionary SET freq=freq+1 WHERE word LIKE '%s'",
						s.c_str (  ) );
	if ( dbres.status (  ) != DB_COMMAND_OK )
	{
		//
		// This is bad if we get here
		//
		cerr << "Failed to update the dictionary. " << db.
			error_message (  ) << endl;
		exit ( 1 );
	}
	return true;
}

long Dictionary::count (  )
{

	char **field;
	long total = 0;

	// Read sorted data and print it out
	db.exec ( &dbres, "SELECT count(word) FROM dictionary" );
	field = dbres.getTuple (  );

	if ( field != NULL )
	{
		total = atoi ( field[0] );	// the 'count' is the first field
	}

	return total;

}

bool Dictionary::erase (  )
{

	db.exec ( &dbres, "DELETE FROM dictionary" );
	if ( dbres.status (  ) != DB_COMMAND_OK )
	{
		//
		// We shouldn't get this far, as we have already checked if the record existed.
		//
		cerr << "Can't delete records from the table 'dictionary' : "
			<< db.error_message (  ) << endl;
		exit ( 1 );
	}
	return 1;
}

Dictionary::~Dictionary (  )
{
}
